<template>
  <div id="contactList">
    <div id="searchInputAndTitle">
      <h1>My Contacts</h1>
      <input
        @input="searchContact"
        placeholder="Search contact"
        id="search-contact"
        v-model="searchedContact"
      />
    </div>
    <button @click="goToAddContact" class="add-contact">+</button>
    <div class="ContactBox" v-for="contact in listOfContact" :key="contact">
      <ContactCard
        class="contact_card"
        @delete-contact-event="emitDeleteContact"
        @see-more-details-event="emitShowContact"
        :details="contact"
      />
    </div>
  </div>
</template>

<script>
import ContactCard from "./ContactCard.vue";
export default {
  name: "ContactList",
  components: {
    ContactCard
  },
  props: {
    listOfContact: { objectType: Array, required: true }
  },
  data() {
    return {
      searchedContact: null
    };
  },
  methods: {
    searchContact() {
      this.$emit("search-contact-event", this.searchedContact);
    },
    goToAddContact() {
      this.$emit("go-to-add-contact-event");
    },
    emitDeleteContact(id) {
      this.$emit("delete-contac-tevent", id);
    },
    emitShowContact(id) {
      this.$emit("see-contact-details-event", id);
    }
  }
};
</script>

<!-- Add "scoped" attribute to limit CSS to this component only -->
<style scoped>
#contactList {
  display: flex;
  flex-direction: column;
}
#searchInputAndTitle {
  display: flex;
  flex-direction: row;
  justify-content: space-around;
  align-items: center;
  margin: 0px 20rem;
}
.add-contact {
  position: fixed;
  top: 86vh;
  left: 80vw;
  padding: 1rem 1.7rem;
  margin: 0rem 5rem;
  border-radius: 10px;
  background: linear-gradient(145deg, #15a7d2, #19c7f9);
  box-shadow: 5px 5px 17px #16b4e2, -5px -5px 17px #18c0f0;
  color: white;
  font-size: 31px;
  font-weight: 600;
  border-style: none;
}
h1 {
  font-size: 21px;
  color: rgb(83, 83, 83);
}
input {
  padding: 0.5rem;
  border-style: none;
  border-radius: 10px;
  font-size: 18px;
  color: rgb(83, 83, 83);
}
.add-contact:focus,
input:focus {
  outline: none;
}
@media all and (max-width: 601px) {
  h1 {
    font-size: 14px;
    width: 30vw;
  }
  input {
    padding: 0.5rem;
    font-size: 12px;
  }
  #searchInputAndTitle {
    margin: 0rem 5rem;
    flex-direction: column;
  }
  .add-contact {
    top: 90vh;
    left: 67vw;
    padding: 0.5rem 0.8rem;
    margin: 0rem 5rem;
    font-size: 18px;
  }
}
</style>
